import sys, random, time

from heappq2 import PriorityQueue

def heapsort(a):
  a.insert(0, None)   # insert dummmy at index 0
  heap = PriorityQueue(a)
  for i in range(len(a)-1, 1, -1):
    a[i] = heap.deletemin()
  a.pop(0)            # remove dummy
  a.reverse()

def check_sorted(a):
  for i in range(len(a) - 1):
    assert(a[i] <= a[i+1])

n = int(sys.argv[1]) if len(sys.argv) == 2 else 100
w = [ random.randrange(1000000) for i in range(n) ]
print(w[:100])
startTime = time.perf_counter()
heapsort(w)
stopTime = time.perf_counter()
check_sorted(w)
print(w[:100])

print("Runtime %g secs" % (stopTime - startTime))
